#include <iostream>
#include <cstdio>
#include <fstream>
#include <sstream>
#include <string>
#include <vector>

using namespace std;

struct mytype{
	int l, t;
	long long c;
	mytype(){
	}
	
	mytype(long long _c, int _l, int _t){
		c = _c;
		l = _l;
		t = _t;
	}
	
	friend bool operator <(const mytype &a, const mytype &b){
		if (a.t < b.t)
			return true;
		else if (a.t > b.t)
			return false;
		else
			return a.l < b.l;
	}
};

long long dp[50][100000 + 1];

int main(){
	ifstream fin("let.in");
	ofstream fout("let.out");
	// solution
	int n, k, T;
	fin >> k >> n >> T;
	mytype d[n];
	for (int i = 0; i < n; i++){
		fin >> d[i].c >> d[i].l >> d[i].t;
		d[i].l--;
	}
	sort(d, d + n);
	memset(dp, 255, sizeof(dp));
	dp[0][0] = 0;
	int lidx = 0;
	long long sum;
	for (int t = 1; t <= T; t++)
		for (int i = 0; i < k; i++){
			sum = 0;
			while (lidx < n && d[lidx].t == t && d[lidx].l == i)
				sum += d[lidx++].c;
			
			if (dp[i][t - 1] != -1)
				dp[i][t] = dp[i][t - 1] + sum;
			if (i - 1 > -1 && dp[i - 1][t - 1] != -1)
				dp[i][t] = max(dp[i][t], dp[i - 1][t - 1] + sum);
			if (i + 1 < k && dp[i + 1][t - 1] != -1)
				dp[i][t] = max(dp[i][t], dp[i + 1][t - 1] + sum);
		}
	long long ret = 0LL;
	for (int i = 0; i < k; i++)
		ret = max(ret, dp[i][T]);

	fout << ret << endl;
	fout.close();
	fin.close();
	return 0;
}
